#include "motor.h"








void Motor::setPins(uint8_t pinA , uint8_t pinB){
  this->pinA = pinA;
  this->pinB = pinB;
}


void Motor::setup(){
  ArduinoAnpassung::setup();
  Timer1.initialize(100); // 10kHz
  Timer1.attachInterrupt(Motor::interruptEinsprung);
  //digitalWrite(LED_BUILTIN , 0 );
}



void Motor::memberSetup(){
  pinMode(pinA , OUTPUT);
  digitalWrite( pinA , 0);

  pinMode(pinB , OUTPUT);
  digitalWrite(pinB , 0);
}



void Motor::memberLoop(){
  if(richtung){
    if(test == 32767)
      richtung = !richtung;
    else
      test ++;
  }else{
    if(test == -32767)
      richtung = !richtung;
    else
      test --;
  }
  setSollSpeed( test / 64);
  //setSollSpeed(100);
  
}


void Motor::setSollSpeed(int16_t speed){
  if(speed > 256)
    speed = 256;
  if((speed < 100) && (speed > -100))
    speed = 0;
  if(speed < -256)
    speed = -256;

  sollSpeed = speed;

}


void Motor::interruptEinsprung(){
  MyList *zeiger;
  zeiger =  ArduinoAnpassung::getErstesElement();
  while(zeiger){
    ((Motor*)zeiger)->memberInterruptEinsprung();
    zeiger = zeiger->getNachfolgerElement();
  }
  
  

}

void Motor::memberInterruptEinsprung(){
  interruptBerechnungen();
  timer ++;
    //digitalWrite(LED_DEBUG , (timer & 0x100) != 0 );
  //digitalWrite(LED_BUILTIN , 1 );
}

void Motor::interruptBerechnungen(){
  summeSpeed += sollSpeed;
  if(summeSpeed >= 256)
  {
    summeSpeed -= 256;
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 1);
    digitalWrite(LED_BUILTIN , 0 );

  }else if (summeSpeed <= -256){
    summeSpeed += 256;
    digitalWrite(pinA , 1);
    digitalWrite(pinB , 0);
    digitalWrite(LED_BUILTIN , 1 );

  }else{
    digitalWrite(pinA , 0);
    digitalWrite(pinB , 0);
    digitalWrite(LED_BUILTIN , 0 );

  }
  
}
